/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20150717-64
 * Copyright (c) 2000 - 2015 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt3.dat, Mon Dec 14 09:44:39 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001A30 (6704)
 *     Revision         0x01
 *     Checksum         0xF3
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "NVIDIAGF"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20110112 (537985298)
 */
DefinitionBlock ("ssdt3.aml", "SSDT", 1, "HPQOEM", "NVIDIAGF", 0x00000001)
{
    /*
     * iASL Warning: There were 6 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.ODGW, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (_SB_.PCI0.PEGP.DGFX.GDCC, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (_SB_.PCI0.PEGP.DGFX.PDOS, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (_SB_.SSMI, MethodObj)    // Warning: Unresolved method, guessing 5 arguments
    External (VRMB, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (VRMS, MethodObj)    // Warning: Unresolved method, guessing 0 arguments

    External (_SB_.BCL_, IntObj)
    External (_SB_.BCM_, IntObj)
    External (_SB_.BEVT, UnknownObj)
    External (_SB_.BQC_, IntObj)
    External (_SB_.DCKD, IntObj)
    External (_SB_.F4EV, UnknownObj)
    External (_SB_.HDDC, IntObj)
    External (_SB_.LID_._LID, IntObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.GFX0.ISBR, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.GACS, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.GPID, UnknownObj)
    External (_SB_.PCI0.PEGP.DGFX, DeviceObj)
    External (_SB_.SBRC, IntObj)
    External (BCCT, IntObj)
    External (BCLV, IntObj)
    External (BRID, IntObj)
    External (BRLV, IntObj)
    External (DCAP, UnknownObj)
    External (DEDP, IntObj)
    External (DID1, UnknownObj)
    External (DODI, IntObj)
    External (DODS, UnknownObj)
    External (GDCC, UnknownObj)
    External (ILUX, UnknownObj)
    External (MDTL, IntObj)
    External (NDOD, IntObj)
    External (PRDT, UnknownObj)
    External (SRCP, UnknownObj)
    External (VACC, UnknownObj)
    External (WCOS, UnknownObj)
    External (WDGN, UnknownObj)
    External (WDPE, UnknownObj)
    External (WDSA, UnknownObj)
    External (WDSS, IntObj)
    External (WDST, IntObj)

    Scope (\_SB.PCI0.PEGP.DGFX)
    {
        Name (MXMV, Buffer (0x79)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x71, 0x00,  /* MXM_..q. */
            /* 0008 */  0x30, 0x11, 0xB8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* 0....>.. */
            /* 0010 */  0x60, 0x7B, 0xE0, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `{...>.. */
            /* 0018 */  0x00, 0x00, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* .....>.. */
            /* 0020 */  0x60, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `i...>.. */
            /* 0028 */  0x60, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `j...>.. */
            /* 0030 */  0x60, 0x6C, 0xEA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `l...>.. */
            /* 0038 */  0x20, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  i...>.. */
            /* 0040 */  0x20, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  j...>.. */
            /* 0048 */  0x20, 0x6C, 0xEA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  l...>.. */
            /* 0050 */  0x01, 0x58, 0x02, 0x00, 0x02, 0x4C, 0x04, 0x00,  /* .X...L.. */
            /* 0058 */  0x13, 0x00, 0x58, 0x02, 0x03, 0x01, 0x90, 0x01,  /* ..X..... */
            /* 0060 */  0x06, 0x10, 0x00, 0x00, 0xDC, 0x05, 0x00, 0x00,  /* ........ */
            /* 0068 */  0xE8, 0x03, 0x00, 0x00, 0x16, 0x14, 0x00, 0x00,  /* ........ */
            /* 0070 */  0xDC, 0x05, 0x00, 0x00, 0xE8, 0x03, 0x00, 0x00,  /* ........ */
            /* 0078 */  0x1E                                             /* . */
        })
        Name (MXM3, Buffer (0x79)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x71, 0x00,  /* MXM_..q. */
            /* 0008 */  0x30, 0x11, 0xB8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* 0....>.. */
            /* 0010 */  0x60, 0x7B, 0xE0, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `{...>.. */
            /* 0018 */  0x00, 0x00, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* .....>.. */
            /* 0020 */  0x60, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `i...>.. */
            /* 0028 */  0x60, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `j...>.. */
            /* 0030 */  0x60, 0x6C, 0xEA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /* `l...>.. */
            /* 0038 */  0x20, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  i...>.. */
            /* 0040 */  0x20, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  j...>.. */
            /* 0048 */  0x20, 0x6C, 0xEA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  /*  l...>.. */
            /* 0050 */  0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,  /* .....L.. */
            /* 0058 */  0x13, 0x00, 0xE8, 0x03, 0x03, 0x01, 0xF4, 0x01,  /* ........ */
            /* 0060 */  0x06, 0x10, 0x00, 0x00, 0xDC, 0x05, 0x00, 0x00,  /* ........ */
            /* 0068 */  0xE8, 0x03, 0x00, 0x00, 0x16, 0x14, 0x00, 0x00,  /* ........ */
            /* 0070 */  0xDC, 0x05, 0x00, 0x00, 0xE8, 0x03, 0x00, 0x00,  /* ........ */
            /* 0078 */  0x98                                             /* . */
        })
        Name (_S3D, 0x03)  // _S3D: S3 Device State
        Name (_S4D, 0x03)  // _S4D: S4 Device State
        Name (INIM, 0x00)
        Name (DIDX, Package (0x09)
        {
            0x0110, 
            0x80000100, 
            0x80004210, 
            0x80006330, 
            0x80006320, 
            0x80006340, 
            0x80002330, 
            0x80002320, 
            0x80002340
        })
        Name (DIDC, 0x00)
        Method (DIDM, 0, Serialized)
        {
            If ((DIDC == 0x00))
            {
                If ((DID1 == 0x00))
                {
                    Index (DODS, 0x00) = DEDP /* External reference */
                }

                Local1 = SizeOf (DODS)
                Local0 = 0x00
                While ((Local0 < Local1))
                {
                    Local2 = DerefOf (Index (DODI, Local0))
                    Local3 = DerefOf (Index (DODS, Local0))
                    Index (DIDX, Local2) = Local3
                    Local0++
                }

                DIDC = 0x01
            }

            Return (DIDX) /* \_SB_.PCI0.PEGP.DGFX.DIDX */
        }

        Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
        {
            Return (NDOD) /* External reference */
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            INIM = 0x01
        }

        Method (_REG, 2, NotSerialized)  // _REG: Region Availability
        {
            If ((INIM == 0x01))
            {
                INIM = 0x00
            }
        }

        Scope (\_GPE)
        {
            Method (VHOV, 3, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    _T_0 = ToInteger (Arg2)
                    If ((_T_0 == 0x01))
                    {
                        If ((Arg0 & 0x80))
                        {
                            Notify (\_SB.PCI0.PEGP.DGFX.LCD, Arg0)
                        }
                        Else
                        {
                            If (((WDPE & 0x44) == 0x00))
                            {
                                \_SB.PCI0.PEGP.DGFX.SBRV ()
                            }
                        }
                    }
                    Else
                    {
                        If ((_T_0 == 0x02))
                        {
                            \_SB.PCI0.PEGP.DGFX.GDCC (0x01, \_SB.PCI0.PEGP.DGFX.DKET ())
                        }
                        Else
                        {
                            If ((_T_0 == 0x03))
                            {
                                \_SB.PCI0.PEGP.DGFX.GLEV ()
                            }
                            Else
                            {
                                If ((_T_0 == 0x04))
                                {
                                    If (((WDPE & 0x03) == 0x00))
                                    {
                                        \_SB.PCI0.PEGP.DGFX.GF4E ()
                                    }
                                }
                                Else
                                {
                                    If ((_T_0 == 0x05))
                                    {
                                        \_SB.PCI0.PEGP.DGFX.GPUP ()
                                    }
                                    Else
                                    {
                                        If ((_T_0 == 0x06))
                                        {
                                            If ((DCAP & 0x01))
                                            {
                                                \_SB.PCI0.PEGP.DGFX.SNXS ()
                                            }
                                            Else
                                            {
                                                Notify (\_SB.PCI0.PEGP.DGFX, 0x80) // Status Change
                                            }
                                        }
                                        Else
                                        {
                                            If ((_T_0 == 0x07))
                                            {
                                                \_SB.PCI0.PEGP.DGFX.RFHS (Arg0)
                                            }
                                            Else
                                            {
                                                If ((_T_0 == 0x08))
                                                {
                                                    \_SB.PCI0.PEGP.DGFX.VWAK (Arg0)
                                                }
                                                Else
                                                {
                                                    If ((_T_0 == 0x0A))
                                                    {
                                                        \_SB.ODGW (0xFF02, \_SB.PCI0.PEGP.DGFX.DGCE ())
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }

                    Break
                }

                Return (0x00)
            }
        }

        Method (_DOS, 1, NotSerialized)  // _DOS: Disable Output Switching
        {
            Local0 = (WDPE & 0xF8)
            Local1 = (WDPE & 0x83)
            WDPE = (Local0 | Arg0)
            If (CondRefOf (^PDOS, Local2))
            {
                ^PDOS (Arg0, Local1)
            }
        }

        Device (LCD)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x00))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                If (\_SB.LID._LID)
                {
                    Return (DCS (0x00))
                }
                Else
                {
                    Return (0x00)
                }
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x00))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x00, Arg0)
            }

            Method (_BCL, 0, Serialized)  // _BCL: Brightness Control Levels
            {
                If ((ILUX == 0x01))
                {
                    Return (\_SB.BCL) /* External reference */
                }
                Else
                {
                    If ((\WCOS <= 0x07))
                    {
                        Return (\_SB.BCL) /* External reference */
                    }
                    Else
                    {
                        Return (Package (0x67)
                        {
                            0x50, 
                            0x32, 
                            0x00, 
                            0x01, 
                            0x02, 
                            0x03, 
                            0x04, 
                            0x05, 
                            0x06, 
                            0x07, 
                            0x08, 
                            0x09, 
                            0x0A, 
                            0x0B, 
                            0x0C, 
                            0x0D, 
                            0x0E, 
                            0x0F, 
                            0x10, 
                            0x11, 
                            0x12, 
                            0x13, 
                            0x14, 
                            0x15, 
                            0x16, 
                            0x17, 
                            0x18, 
                            0x19, 
                            0x1A, 
                            0x1B, 
                            0x1C, 
                            0x1D, 
                            0x1E, 
                            0x1F, 
                            0x20, 
                            0x21, 
                            0x22, 
                            0x23, 
                            0x24, 
                            0x25, 
                            0x26, 
                            0x27, 
                            0x28, 
                            0x29, 
                            0x2A, 
                            0x2B, 
                            0x2C, 
                            0x2D, 
                            0x2E, 
                            0x2F, 
                            0x30, 
                            0x31, 
                            0x32, 
                            0x33, 
                            0x34, 
                            0x35, 
                            0x36, 
                            0x37, 
                            0x38, 
                            0x39, 
                            0x3A, 
                            0x3B, 
                            0x3C, 
                            0x3D, 
                            0x3E, 
                            0x3F, 
                            0x40, 
                            0x41, 
                            0x42, 
                            0x43, 
                            0x45, 
                            0x45, 
                            0x46, 
                            0x47, 
                            0x48, 
                            0x49, 
                            0x4A, 
                            0x4B, 
                            0x4C, 
                            0x4D, 
                            0x4E, 
                            0x4F, 
                            0x50, 
                            0x51, 
                            0x52, 
                            0x53, 
                            0x54, 
                            0x55, 
                            0x56, 
                            0x57, 
                            0x58, 
                            0x59, 
                            0x5A, 
                            0x5B, 
                            0x5C, 
                            0x5D, 
                            0x5E, 
                            0x5F, 
                            0x60, 
                            0x61, 
                            0x62, 
                            0x63, 
                            0x64
                        })
                    }
                }
            }

            Method (_BCM, 1, Serialized)  // _BCM: Brightness Control Method
            {
                Arg0 = \_SB.BCM /* External reference */
                Local0
                If (Local0)
                {
                    Local1 = BRID /* External reference */
                    If ((VACC == 0x00))
                    {
                        If ((\_SB.PCI0.GFX0.ISBR == 0x00))
                        {
                            \_SB.SSMI (0xEA74, 0x04, Local1, 0x00, 0x00)
                        }
                    }
                    Else
                    {
                        If ((\_SB.PCI0.PEGP.DGFX.SBRV () == 0x00))
                        {
                            \_SB.SSMI (0xEA74, 0x04, Local1, 0x00, 0x00)
                        }
                    }

                    Signal (\_SB.BEVT)
                }
            }

            Method (_BQC, 0, Serialized)  // _BQC: Brightness Query Current
            {
                Return (\_SB.BQC) /* External reference */
            }
        }

        Device (CRT)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x01))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x01))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x01))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x01, Arg0)
            }
        }

        Device (TV)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x02))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x02))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x02))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x02, Arg0)
            }
        }

        Device (DVI)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x03))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x03))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x03))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x03, Arg0)
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x04))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x04))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x04))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x04, Arg0)
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x05))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x05))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x05))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x05, Arg0)
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x06))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x06))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x06))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x06, Arg0)
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x07))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x07))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x07))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x07, Arg0)
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x08))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x08))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x08))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x08, Arg0)
            }
        }

        Method (ADR, 1, Serialized)
        {
            Local1 = DIDM ()
            Local2 = SizeOf (Local1)
            If ((Arg0 < Local2))
            {
                Local0 = DerefOf (Index (Local1, Arg0))
                If ((\WCOS < 0x06))
                {
                    Local0 &= 0xFFFF
                }
            }
            Else
            {
                Local0 = 0x00
            }

            Return (Local0)
        }

        Method (DCS, 1, Serialized)
        {
            Local1 = (0x01 << Arg0)
            Local0 = 0x00
            If (Local0 = 0x01 = (GDCC (0x00, Local1) & Zero))
            {
                If ((WDST & Local1))
                {
                    Local0 = 0x1D
                    If ((WDSA & Local1))
                    {
                        Local0 = 0x1F
                    }
                }
            }

            Return (Local0)
        }

        Method (DGS, 1, Serialized)
        {
            Local2 = (0x01 << Arg0)
            Local0 = 0x00
            If ((WDGN & Local2))
            {
                Local0 = 0x01
            }

            Return (Local0)
        }

        Method (DSS, 2, Serialized)
        {
            Local1 = (0x01 << Arg0)
            Local0 = WDSS /* External reference */
            If ((Arg1 & 0x01))
            {
                Local0 |= Local1
            }
            Else
            {
                Local0 &= ~Local1
            }

            WDSS = Local0
            If ((Arg1 & 0x40000000))
            {
                WDSA = Local0
            }
        }

        Scope (\_SB.PCI0.PEGP.DGFX)
        {
            OperationRegion (NVMX, PCI_Config, 0x00, 0x02)
            Field (NVMX, WordAcc, NoLock, Preserve)
            {
                DVID,   16
            }

            Method (MXID, 0, NotSerialized)
            {
                Local0 = MXMV /* \_SB_.PCI0.PEGP.DGFX.MXMV */
                If (((PRDT == 0x04) || (PRDT == 0x06)))
                {
                    Local0 = MXMV /* \_SB_.PCI0.PEGP.DGFX.MXMV */
                }
                Else
                {
                    If (((PRDT == 0x05) || (PRDT == 0x07)))
                    {
                        Local0 = MXM3 /* \_SB_.PCI0.PEGP.DGFX.MXM3 */
                    }
                }

                Return (Local0)
            }

            Method (MXMI, 1, NotSerialized)
            {
                If ((Arg0 == 0x30))
                {
                    Return (Arg0)
                }

                If ((Arg0 == 0x00))
                {
                    Return (0x30)
                }

                Return (0x00)
            }

            Method (MXMS, 1, NotSerialized)
            {
                If ((Arg0 == 0x30))
                {
                    Return (MXID ())
                }

                Return (0x00)
            }

            Method (UCMP, 2, NotSerialized)
            {
                If ((0x10 != SizeOf (Arg0)))
                {
                    Return (0x00)
                }

                If ((0x10 != SizeOf (Arg1)))
                {
                    Return (0x00)
                }

                Local0 = 0x00
                While ((Local0 < 0x10))
                {
                    If ((DerefOf (Index (Arg0, Local0)) != DerefOf (Index (Arg1, Local0
                        ))))
                    {
                        Return (0x00)
                    }

                    Local0++
                }

                Return (0x01)
            }

            Method (MDSM, 4, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                Debug = "-----DGPU _DSM --------"
                Debug = Arg1
                Debug = Arg2
                Debug = Arg3
                If ((Arg1 != 0x0300))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    _T_0 = ToInteger (Arg2)
                    If ((_T_0 == 0x00))
                    {
                        Return (Buffer (0x04)
                        {
                             0x01, 0x00, 0x01, 0x01                           /* .... */
                        })
                    }
                    Else
                    {
                        If ((_T_0 == 0x18))
                        {
                            Return (Buffer (0x01)
                            {
                                 0x30                                             /* 0 */
                            })
                        }
                        Else
                        {
                            If ((_T_0 == 0x10))
                            {
                                CreateWordField (Arg3, 0x02, SUBF)
                                If (((SUBF == 0x30) || (SUBF == 0x00)))
                                {
                                    Return (MXID ())
                                }
                                Else
                                {
                                    If (((SUBF < 0x80) || (SUBF > 0x8F)))
                                    {
                                        Return (0x80000001)
                                    }
                                }
                            }
                        }
                    }

                    Break
                }

                Return (0x80000002)
            }
        }

        Scope (\_SB.PCI0)
        {
            Device (WMI1)
            {
                Name (_HID, EisaId ("PNP0C14") /* Windows Management Instrumentation Device */)  // _HID: Hardware ID
                Name (_UID, "MXM2")  // _UID: Unique ID
                Name (_WDG, Buffer (0xA0)
                {
                    /* 0000 */  0x3C, 0x5C, 0xCB, 0xF6, 0xAE, 0x9C, 0xBD, 0x4E,  /* <\.....N */
                    /* 0008 */  0xB5, 0x77, 0x93, 0x1E, 0xA3, 0x2A, 0x2C, 0xC0,  /* .w...*,. */
                    /* 0010 */  0x4D, 0x58, 0x01, 0x02, 0x21, 0x12, 0x90, 0x05,  /* MX..!... */
                    /* 0018 */  0x66, 0xD5, 0xD1, 0x11, 0xB2, 0xF0, 0x00, 0xA0,  /* f....... */
                    /* 0020 */  0xC9, 0x06, 0x29, 0x10, 0x58, 0x4D, 0x01, 0x00,  /* ..).XM.. */
                    /* 0028 */  0x40, 0x2F, 0x1A, 0x92, 0xC4, 0x0D, 0x2D, 0x40,  /* @/....-@ */
                    /* 0030 */  0xAC, 0x18, 0xB4, 0x84, 0x44, 0xEF, 0x9E, 0xD2,  /* ....D... */
                    /* 0038 */  0xD0, 0x00, 0x01, 0x08, 0x95, 0x30, 0x26, 0x93,  /* .....0&. */
                    /* 0040 */  0x5F, 0xDA, 0xA0, 0x46, 0x8B, 0x1C, 0xDB, 0x2F,  /* _..F.../ */
                    /* 0048 */  0x1F, 0x7D, 0x66, 0xAF, 0xD1, 0x00, 0x01, 0x08,  /* .}f..... */
                    /* 0050 */  0x06, 0x70, 0x90, 0xBE, 0x03, 0xD6, 0x14, 0x47,  /* .p.....G */
                    /* 0058 */  0x9A, 0xE2, 0x9D, 0xBA, 0x89, 0x97, 0xA8, 0x05,  /* ........ */
                    /* 0060 */  0xD2, 0x00, 0x01, 0x08, 0xE1, 0x55, 0xD3, 0x21,  /* .....U.! */
                    /* 0068 */  0x8D, 0x49, 0x1F, 0x4C, 0xAE, 0x01, 0x05, 0xCE,  /* .I.L.... */
                    /* 0070 */  0xF8, 0xDD, 0x05, 0x3F, 0xD3, 0x00, 0x01, 0x08,  /* ...?.... */
                    /* 0078 */  0xF1, 0xED, 0xBC, 0xED, 0xC9, 0xBB, 0x0E, 0x42,  /* .......B */
                    /* 0080 */  0xA3, 0xC0, 0x32, 0x2B, 0x1D, 0x37, 0xC3, 0xAA,  /* ..2+.7.. */
                    /* 0088 */  0xD4, 0x00, 0x01, 0x08, 0xE1, 0x84, 0x7E, 0x37,  /* ......~7 */
                    /* 0090 */  0xDE, 0x13, 0xFB, 0x41, 0xA0, 0x96, 0x0F, 0x08,  /* ...A.... */
                    /* 0098 */  0x52, 0x8B, 0xA6, 0x89, 0xD5, 0x00, 0x01, 0x08   /* R....... */
                })
                Method (WMMX, 3, NotSerialized)
                {
                    CreateDWordField (Arg2, 0x00, FUNC)
                    If ((SizeOf (Arg2) >= 0x04))
                    {
                        CreateDWordField (Arg2, 0x04, ARGA)
                    }

                    If ((SizeOf (Arg2) >= 0x08))
                    {
                        CreateDWordField (Arg2, 0x08, ARGB)
                    }

                    If ((FUNC == 0x4D53445F))
                    {
                        If ((SizeOf (Arg2) >= 0x1C))
                        {
                            CreateField (Arg2, 0x20, 0x80, MUID)
                            CreateDWordField (Arg2, 0x14, REVI)
                            CreateDWordField (Arg2, 0x18, SFNC)
                            CreateDWordField (Arg2, 0x1C, ARGD)
                            Return (\_SB.PCI0.PEGP.DGFX._DSM (MUID, REVI, SFNC, ARGD))
                        }
                    }

                    If ((FUNC == 0x494D584D))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.MXMI (ARGA))
                    }

                    If ((FUNC == 0x534D584D))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.MXMS (ARGA))
                    }

                    If ((FUNC == 0x4C43425F))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.LCD._BCL ())
                    }

                    Return (0x00)
                }

                Name (WQXM, Buffer (0x0580)
                {
                    /* 0000 */  0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,  /* FOMB.... */
                    /* 0008 */  0x70, 0x05, 0x00, 0x00, 0xE4, 0x2C, 0x00, 0x00,  /* p....,.. */
                    /* 0010 */  0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,  /* DS...}.T */
                    /* 0018 */  0x18, 0xD2, 0x95, 0x00, 0x01, 0x06, 0x18, 0x42,  /* .......B */
                    /* 0020 */  0x10, 0x17, 0x10, 0x8A, 0xE6, 0x80, 0x42, 0x04,  /* ......B. */
                    /* 0028 */  0x92, 0x43, 0xA4, 0x30, 0x30, 0x28, 0x0B, 0x20,  /* .C.00(.  */
                    /* 0030 */  0x86, 0xA4, 0x04, 0x16, 0x01, 0x21, 0xAF, 0x02,  /* .....!.. */
                    /* 0038 */  0x6C, 0x0A, 0x30, 0x09, 0xA2, 0xFE, 0xFD, 0x21,  /* l.0....! */
                    /* 0040 */  0x4A, 0x82, 0x43, 0x09, 0x81, 0x90, 0x44, 0x01,  /* J.C...D. */
                    /* 0048 */  0xE6, 0x05, 0xE8, 0x16, 0x60, 0x58, 0x80, 0x6D,  /* ....`X.m */
                    /* 0050 */  0x01, 0xA6, 0x05, 0x38, 0x86, 0xA4, 0xD2, 0xC0,  /* ...8.... */
                    /* 0058 */  0x29, 0x81, 0xA5, 0x40, 0x48, 0xA8, 0x00, 0xE5,  /* )..@H... */
                    /* 0060 */  0x02, 0x7C, 0x0B, 0xD0, 0x8E, 0x28, 0xC9, 0x02,  /* .|...(.. */
                    /* 0068 */  0x2C, 0xC3, 0x88, 0xC0, 0xA3, 0x60, 0x68, 0x1C,  /* ,....`h. */
                    /* 0070 */  0x1A, 0x3B, 0x0C, 0xCB, 0x04, 0xD3, 0x20, 0x0E,  /* .;.... . */
                    /* 0078 */  0xA3, 0x6C, 0x64, 0x11, 0x18, 0xB7, 0x53, 0x01,  /* .ld...S. */
                    /* 0080 */  0x72, 0x05, 0x08, 0x13, 0x20, 0x1E, 0x55, 0x18,  /* r... .U. */
                    /* 0088 */  0xCD, 0x41, 0x11, 0xB8, 0xD0, 0x18, 0x19, 0x10,  /* .A...... */
                    /* 0090 */  0xF2, 0x28, 0xC0, 0xEA, 0x28, 0x34, 0xA9, 0x04,  /* .(..(4.. */
                    /* 0098 */  0x76, 0x2F, 0x40, 0xA3, 0x00, 0x6D, 0x02, 0x1C,  /* v/@..m.. */
                    /* 00A0 */  0x0A, 0x50, 0x28, 0xC0, 0x1A, 0x86, 0x9C, 0x41,  /* .P(....A */
                    /* 00A8 */  0xC8, 0x16, 0xB6, 0x30, 0x1A, 0x14, 0x60, 0x11,  /* ...0..`. */
                    /* 00B0 */  0x45, 0x23, 0x38, 0x8B, 0x8A, 0xE7, 0x24, 0x94,  /* E#8...$. */
                    /* 00B8 */  0x80, 0xF6, 0x86, 0x20, 0x3C, 0x63, 0x36, 0x86,  /* ... <c6. */
                    /* 00C0 */  0x27, 0xC4, 0x20, 0x95, 0x61, 0x08, 0x22, 0x6E,  /* '. .a."n */
                    /* 00C8 */  0x84, 0x63, 0x69, 0x7F, 0x10, 0x44, 0xBE, 0x82,  /* .ci..D.. */
                    /* 00D0 */  0x71, 0xB3, 0x48, 0xA3, 0x41, 0x8D, 0x35, 0xC1,  /* q.H.A.5. */
                    /* 00D8 */  0xB1, 0x7B, 0x34, 0x27, 0xDC, 0xB9, 0x00, 0xE9,  /* .{4'.... */
                    /* 00E0 */  0x73, 0x13, 0xC8, 0xD1, 0x9D, 0x46, 0x9D, 0x83,  /* s....F.. */
                    /* 00E8 */  0x26, 0xC3, 0x63, 0x58, 0x09, 0xFE, 0x03, 0x7C,  /* &.cX...| */
                    /* 00F0 */  0x0A, 0xC0, 0xBB, 0x06, 0xD4, 0xF4, 0x0F, 0x9E,  /* ........ */
                    /* 00F8 */  0x09, 0x82, 0x43, 0x0D, 0xD1, 0xA3, 0x0E, 0x77,  /* ..C....w */
                    /* 0100 */  0x02, 0xE7, 0x75, 0x24, 0x0C, 0xE2, 0x88, 0x8E,  /* ..u$.... */
                    /* 0108 */  0x1B, 0x3B, 0xAB, 0x93, 0x39, 0xE8, 0x52, 0x05,  /* .;..9.R. */
                    /* 0110 */  0x98, 0x3D, 0x00, 0x68, 0x70, 0x09, 0x4E, 0xFB,  /* .=.hp.N. */
                    /* 0118 */  0x4C, 0x42, 0xBF, 0x07, 0x9C, 0x4F, 0xCF, 0x63,  /* LB...O.c */
                    /* 0120 */  0x63, 0x83, 0x40, 0x8D, 0xCC, 0xFF, 0x7F, 0x68,  /* c.@....h */
                    /* 0128 */  0x0F, 0xF2, 0xB4, 0x62, 0x86, 0x7C, 0x16, 0x38,  /* ...b.|.8 */
                    /* 0130 */  0x2C, 0x26, 0x16, 0x42, 0x9B, 0xD4, 0x78, 0x80,  /* ,&.B..x. */
                    /* 0138 */  0xC0, 0x01, 0xE0, 0xD1, 0x20, 0xC2, 0x9B, 0x81,  /* .... ... */
                    /* 0140 */  0xE7, 0x6B, 0x82, 0x41, 0x21, 0xE4, 0x64, 0x3C,  /* .k.A!.d< */
                    /* 0148 */  0x28, 0x31, 0xE7, 0x03, 0x32, 0x97, 0x10, 0x0F,  /* (1..2... */
                    /* 0150 */  0x01, 0xC7, 0x10, 0x23, 0xE8, 0x19, 0x15, 0x8D,  /* ...#.... */
                    /* 0158 */  0xAC, 0x89, 0xF8, 0x0C, 0xE0, 0x71, 0x5B, 0x16,  /* .....q[. */
                    /* 0160 */  0x08, 0x25, 0x30, 0xB0, 0xCF, 0x0D, 0xEF, 0x10,  /* .%0..... */
                    /* 0168 */  0x86, 0xC5, 0x8D, 0x26, 0xB0, 0xCF, 0x17, 0x16,  /* ...&.... */
                    /* 0170 */  0x38, 0x28, 0x14, 0xAC, 0xEF, 0x0A, 0x31, 0x9F,  /* 8(....1. */
                    /* 0178 */  0x07, 0x8E, 0xF3, 0x80, 0x2D, 0x7C, 0xA2, 0x04,  /* ....-|.. */
                    /* 0180 */  0xF8, 0x90, 0x3C, 0x1A, 0x78, 0x83, 0x84, 0x6F,  /* ..<.x..o */
                    /* 0188 */  0xFD, 0x08, 0x40, 0x80, 0x9F, 0x18, 0x4C, 0x60,  /* ..@...L` */
                    /* 0190 */  0x79, 0xC0, 0xE8, 0x51, 0xDA, 0xAF, 0x00, 0x84,  /* y..Q.... */
                    /* 0198 */  0xE0, 0x2F, 0x16, 0x4F, 0x01, 0xAF, 0x03, 0x11,  /* ./.O.... */
                    /* 01A0 */  0x8E, 0x05, 0xA6, 0xC8, 0xB1, 0xA1, 0xE1, 0xF9,  /* ........ */
                    /* 01A8 */  0xC1, 0x21, 0x7A, 0xD4, 0x73, 0x09, 0x7F, 0x34,  /* .!z.s..4 */
                    /* 01B0 */  0x51, 0x4E, 0xE1, 0x70, 0x7C, 0xE4, 0x30, 0x42,  /* QN.p|.0B */
                    /* 01B8 */  0xF8, 0x27, 0x8D, 0x27, 0x0F, 0x6B, 0xBE, 0x03,  /* .'.'.k.. */
                    /* 01C0 */  0x68, 0x4A, 0x6F, 0x01, 0xEF, 0x0F, 0x1E, 0x01,  /* hJo..... */
                    /* 01C8 */  0x46, 0x80, 0x84, 0xA3, 0x09, 0x26, 0xF2, 0xE9,  /* F....&.. */
                    /* 01D0 */  0x04, 0x54, 0xFF, 0xFF, 0xD3, 0x09, 0x60, 0x6A,  /* .T....`j */
                    /* 01D8 */  0xCA, 0x41, 0xDF, 0x4E, 0x9E, 0x22, 0x02, 0x45,  /* .A.N.".E */
                    /* 01E0 */  0x09, 0xF2, 0x12, 0xF0, 0x56, 0x12, 0x24, 0xC2,  /* ....V.$. */
                    /* 01E8 */  0x7B, 0xC9, 0x93, 0xC9, 0xD3, 0x89, 0xC5, 0x9D,  /* {....... */
                    /* 01F0 */  0x52, 0x84, 0x11, 0xE5, 0xE8, 0x03, 0x85, 0x79,  /* R......y */
                    /* 01F8 */  0x31, 0x78, 0x3F, 0x31, 0x64, 0x90, 0xB0, 0x9E,  /* 1x?1d... */
                    /* 0200 */  0x47, 0xAC, 0x38, 0x01, 0x83, 0x45, 0x79, 0x43,  /* G.8..EyC */
                    /* 0208 */  0x79, 0x3A, 0x61, 0x21, 0x1F, 0x1A, 0xD2, 0x70,  /* y:a!...p */
                    /* 0210 */  0x3A, 0x01, 0x28, 0xF0, 0xFF, 0x3F, 0x9D, 0xC0,  /* :.(..?.. */
                    /* 0218 */  0x8F, 0x7A, 0x3A, 0x41, 0x0F, 0xD7, 0xA7, 0x0C,  /* .z:A.... */
                    /* 0220 */  0x0C, 0xF2, 0x01, 0xF9, 0xD4, 0xE1, 0x73, 0xC0,  /* ......s. */
                    /* 0228 */  0x69, 0xF8, 0x78, 0x82, 0x11, 0x75, 0x3C, 0x41,  /* i.x..u<A */
                    /* 0230 */  0x9D, 0x1E, 0x7C, 0x3C, 0x61, 0xE7, 0x83, 0xB3,  /* ..|<a... */
                    /* 0238 */  0x78, 0x0C, 0xF0, 0xE9, 0x04, 0x73, 0x4F, 0xF0,  /* x....sO. */
                    /* 0240 */  0xE9, 0x04, 0x6C, 0xA3, 0x81, 0x71, 0x3C, 0x01,  /* ..l..q<. */
                    /* 0248 */  0xDF, 0xD1, 0x05, 0x77, 0x3C, 0x01, 0xC3, 0x60,  /* ...w<..` */
                    /* 0250 */  0x60, 0x9C, 0x4F, 0x80, 0xC7, 0x78, 0x71, 0xC7,  /* `.O..xq. */
                    /* 0258 */  0x00, 0x0F, 0x81, 0x0F, 0xE0, 0x71, 0xE3, 0xF4,  /* .....q.. */
                    /* 0260 */  0xAC, 0x74, 0x52, 0xC8, 0x93, 0x08, 0x1F, 0x14,  /* .tR..... */
                    /* 0268 */  0xE6, 0xC0, 0x02, 0x1C, 0xFE, 0xFF, 0x07, 0x16,  /* ........ */
                    /* 0270 */  0xC0, 0xD4, 0xFD, 0xE0, 0x94, 0x9F, 0x57, 0x7C,  /* ......W| */
                    /* 0278 */  0x61, 0x31, 0xF2, 0x3B, 0xCA, 0x8B, 0x4A, 0x8C,  /* a1.;..J. */
                    /* 0280 */  0x03, 0x7F, 0x57, 0x89, 0xE2, 0x11, 0xBC, 0xA9,  /* ..W..... */
                    /* 0288 */  0x44, 0x0B, 0xF6, 0xC0, 0xE2, 0xE3, 0x8A, 0x8F,  /* D....... */
                    /* 0290 */  0x68, 0xC6, 0x8B, 0x75, 0x18, 0xAF, 0x2E, 0x46,  /* h..u...F */
                    /* 0298 */  0x8A, 0x12, 0x33, 0xDE, 0xCB, 0x9A, 0x21, 0x1E,  /* ..3...!. */
                    /* 02A0 */  0x58, 0x00, 0x36, 0xFC, 0xFF, 0x0F, 0x2C, 0xC0,  /* X.6...,. */
                    /* 02A8 */  0xE4, 0x1A, 0xF4, 0xC0, 0x02, 0x8C, 0x47, 0xC3,  /* ......G. */
                    /* 02B0 */  0x0E, 0x2C, 0xC0, 0x74, 0x30, 0xEC, 0xC0, 0x02,  /* .,.t0... */
                    /* 02B8 */  0xB8, 0xFC, 0xFF, 0x1F, 0x58, 0x00, 0x53, 0x07,  /* ....X.S. */
                    /* 02C0 */  0x52, 0xDF, 0x55, 0x62, 0x3C, 0x93, 0x32, 0x84,  /* R.Ub<.2. */
                    /* 02C8 */  0x17, 0x95, 0xF7, 0x34, 0x1F, 0xD8, 0xF8, 0xD5,  /* ...4.... */
                    /* 02D0 */  0xC0, 0x07, 0x83, 0xB7, 0x35, 0x83, 0x44, 0x7A,  /* ....5.Dz */
                    /* 02D8 */  0x60, 0xF1, 0xD5, 0xC5, 0x10, 0x41, 0x23, 0xC6,  /* `....A#. */
                    /* 02E0 */  0x88, 0xFA, 0xC0, 0xF2, 0xE0, 0x66, 0x9C, 0x18,  /* .....f.. */
                    /* 02E8 */  0x0F, 0x2C, 0x00, 0x1B, 0xFE, 0xFF, 0x07, 0x16,  /* .,...... */
                    /* 02F0 */  0x60, 0x72, 0x15, 0x7A, 0x60, 0x01, 0xC6, 0xA3,  /* `r.z`... */
                    /* 02F8 */  0x61, 0x07, 0x16, 0x60, 0x3A, 0x18, 0x76, 0x60,  /* a..`:.v` */
                    /* 0300 */  0x01, 0x5C, 0xFE, 0xFF, 0x0F, 0x6C, 0x80, 0xAB,  /* .\...l.. */
                    /* 0308 */  0x2B, 0xCA, 0x13, 0xAA, 0xEF, 0x29, 0x51, 0x5E,  /* +....)Q^ */
                    /* 0310 */  0x51, 0x7C, 0x5B, 0x31, 0x88, 0x6F, 0x2B, 0x3E,  /* Q|[1.o+> */
                    /* 0318 */  0xA8, 0xF9, 0x6C, 0xF0, 0xC0, 0x6A, 0x40, 0x76,  /* ..l..j@v */
                    /* 0320 */  0x60, 0x35, 0xC4, 0x53, 0xAB, 0x11, 0x9E, 0x00,  /* `5.S.... */
                    /* 0328 */  0x82, 0x87, 0x3B, 0x91, 0x60, 0x11, 0x1E, 0x5D,  /* ..;.`..] */
                    /* 0330 */  0x7C, 0x60, 0x01, 0xD8, 0xF0, 0xFF, 0x3F, 0xB0,  /* |`....?. */
                    /* 0338 */  0x00, 0x93, 0x9B, 0xC0, 0x03, 0x0B, 0x30, 0x1E,  /* ......0. */
                    /* 0340 */  0x0D, 0x3B, 0xB0, 0x00, 0xD3, 0xC1, 0xB0, 0x03,  /* .;...... */
                    /* 0348 */  0x0B, 0xE0, 0xF2, 0xFF, 0x7F, 0x60, 0x01, 0x4C,  /* .....`.L */
                    /* 0350 */  0x41, 0xBE, 0x13, 0xBC, 0xAB, 0x9C, 0x73, 0x8C,  /* A.....s. */
                    /* 0358 */  0x57, 0x34, 0x43, 0xBF, 0xA8, 0xFA, 0x94, 0xEA,  /* W4C..... */
                    /* 0360 */  0xDB, 0x8A, 0x81, 0x0C, 0x76, 0x4E, 0x0F, 0xAC,  /* ....vN.. */
                    /* 0368 */  0x46, 0x7A, 0x6A, 0x61, 0xB7, 0x55, 0x83, 0x3C,  /* Fzja.U.< */
                    /* 0370 */  0xB9, 0x18, 0xE1, 0xE8, 0x43, 0x1F, 0xC0, 0x8B,  /* ....C... */
                    /* 0378 */  0xAB, 0x0F, 0x2C, 0x00, 0x1F, 0xFE, 0xFF, 0x07,  /* ..,..... */
                    /* 0380 */  0x16, 0xE0, 0x71, 0x2A, 0xF6, 0x81, 0x05, 0xF8,  /* ..q*.... */
                    /* 0388 */  0x8E, 0x86, 0x1F, 0x58, 0x80, 0xE7, 0x60, 0xF8,  /* ...X..`. */
                    /* 0390 */  0x81, 0x05, 0x70, 0xF9, 0xFF, 0x3F, 0xB0, 0x00,  /* ..p..?.. */
                    /* 0398 */  0xAE, 0x0E, 0x08, 0xBE, 0x10, 0xC6, 0x08, 0xEC,  /* ........ */
                    /* 03A0 */  0xDB, 0xAA, 0xD1, 0x8E, 0xFB, 0x81, 0x1D, 0x33,  /* .......3 */
                    /* 03A8 */  0x8E, 0xA7, 0x16, 0x5F, 0x56, 0x5E, 0x30, 0x1E,  /* ..._V^0. */
                    /* 03B0 */  0x58, 0x0E, 0x3F, 0x9E, 0xAF, 0xEC, 0xC6, 0x7B,  /* X.?....{ */
                    /* 03B8 */  0x5A, 0xF5, 0xF1, 0x28, 0x4E, 0xC4, 0x08, 0x81,  /* Z..(N... */
                    /* 03C0 */  0x1F, 0x58, 0x01, 0x3E, 0xFC, 0xFF, 0x0F, 0x2C,  /* .X.>..., */
                    /* 03C8 */  0xC0, 0xE4, 0xC0, 0x0E, 0x8C, 0x47, 0xC3, 0x0F,  /* .....G.. */
                    /* 03D0 */  0x2C, 0xC0, 0xF4, 0xC0, 0x0E, 0x18, 0xFD, 0xFF,  /* ,....... */
                    /* 03D8 */  0x1F, 0x58, 0x00, 0x53, 0x77, 0x74, 0x83, 0x86,  /* .X.Swt.. */
                    /* 03E0 */  0x7D, 0x46, 0x09, 0x11, 0xE1, 0x19, 0xE5, 0x45,  /* }F.....E */
                    /* 03E8 */  0xC5, 0x18, 0x51, 0x9E, 0x55, 0x3D, 0x82, 0x58,  /* ..Q.U=.X */
                    /* 03F0 */  0xCF, 0x05, 0xAF, 0x6C, 0x46, 0x3C, 0xF8, 0xA0,  /* ...lF<.. */
                    /* 03F8 */  0x8F, 0x07, 0x51, 0x7C, 0x61, 0x31, 0xCE, 0x4B,  /* ..Q|a1.K */
                    /* 0400 */  0x4B, 0x94, 0x08, 0x01, 0xA3, 0xF8, 0xDC, 0xEE,  /* K....... */
                    /* 0408 */  0x03, 0x0B, 0xC0, 0x86, 0xFF, 0xFF, 0x81, 0x05,  /* ........ */
                    /* 0410 */  0x98, 0x9C, 0x43, 0xD8, 0x81, 0x05, 0xD8, 0x8E,  /* ..C..... */
                    /* 0418 */  0x86, 0x1D, 0x58, 0x80, 0xE9, 0x00, 0xD8, 0x81,  /* ..X..... */
                    /* 0420 */  0x05, 0x70, 0xF9, 0xFF, 0x3F, 0xB0, 0x00, 0xA6,  /* .p..?... */
                    /* 0428 */  0xEE, 0xAB, 0x86, 0x79, 0x42, 0x78, 0x44, 0xF7,  /* ...yBxD. */
                    /* 0430 */  0x88, 0x1F, 0xD8, 0x19, 0xF8, 0x53, 0x4A, 0xA8,  /* .....SJ. */
                    /* 0438 */  0x28, 0x1E, 0x47, 0xA4, 0xF7, 0x80, 0x07, 0x56,  /* (.G....V */
                    /* 0440 */  0xC3, 0x1D, 0x44, 0x3C, 0x9F, 0x55, 0x7C, 0x22,  /* ..D<.U|" */
                    /* 0448 */  0xF0, 0xE9, 0xDD, 0x90, 0xCF, 0x87, 0xBE, 0xB6,  /* ........ */
                    /* 0450 */  0xFB, 0xC0, 0x06, 0xF0, 0xE1, 0xFF, 0x7F, 0x60,  /* .......` */
                    /* 0458 */  0x01, 0x26, 0xE7, 0x80, 0x07, 0x16, 0x60, 0x3C,  /* .&....`< */
                    /* 0460 */  0x1A, 0x76, 0x60, 0x01, 0xA6, 0x83, 0x61, 0x07,  /* .v`...a. */
                    /* 0468 */  0x16, 0xC0, 0xE5, 0xFF, 0xFF, 0xC0, 0x02, 0x98,  /* ........ */
                    /* 0470 */  0xBA, 0x9F, 0xFB, 0x5E, 0xF1, 0x16, 0x60, 0x90,  /* ...^..`. */
                    /* 0478 */  0xB7, 0x54, 0x5F, 0xD4, 0x0D, 0x64, 0xF8, 0x07,  /* .T_..d.. */
                    /* 0480 */  0x16, 0x5F, 0x0D, 0x3C, 0x8D, 0x07, 0x16, 0x9F,  /* ._.<.... */
                    /* 0488 */  0x0C, 0x42, 0xBD, 0xB2, 0xFA, 0xAE, 0x60, 0x84,  /* .B....`. */
                    /* 0490 */  0x77, 0x56, 0x1F, 0x0F, 0x7C, 0x60, 0x8B, 0x15,  /* wV..|`.. */
                    /* 0498 */  0x23, 0x5E, 0x84, 0x07, 0x16, 0x80, 0x0D, 0xFF,  /* #^...... */
                    /* 04A0 */  0xFF, 0x03, 0x0B, 0x30, 0xB9, 0x2C, 0xF8, 0xC0,  /* ...0.,.. */
                    /* 04A8 */  0x02, 0x7C, 0x47, 0xC3, 0x0E, 0x2C, 0xC0, 0x74,  /* .|G..,.t */
                    /* 04B0 */  0x30, 0xEC, 0xC0, 0x02, 0xB8, 0xFC, 0xFF, 0x1F,  /* 0....... */
                    /* 04B8 */  0x58, 0x00, 0x53, 0x27, 0x14, 0x23, 0x9C, 0xEF,  /* X.S'.#.. */
                    /* 04C0 */  0x3B, 0x5A, 0xE4, 0x07, 0x36, 0x06, 0x11, 0x2A,  /* ;Z..6..* */
                    /* 04C8 */  0x5E, 0x98, 0x07, 0x16, 0xDF, 0xD7, 0xAC, 0xF8,  /* ^....... */
                    /* 04D0 */  0xC0, 0x42, 0xE6, 0xE0, 0x7B, 0xAB, 0x41, 0xDE,  /* .B..{.A. */
                    /* 04D8 */  0x5C, 0x42, 0xC4, 0x7D, 0x5B, 0x7B, 0x43, 0x78,  /* \B.}[{Cx */
                    /* 04E0 */  0x6B, 0x37, 0x5A, 0xAC, 0x67, 0x56, 0x1F, 0x58,  /* k7Z.gV.X */
                    /* 04E8 */  0x00, 0x36, 0xFC, 0xFF, 0x0F, 0x2C, 0xC0, 0xE4,  /* .6...,.. */
                    /* 04F0 */  0x28, 0xF0, 0xC0, 0x02, 0x8C, 0x47, 0xC3, 0x0E,  /* (....G.. */
                    /* 04F8 */  0x2C, 0xC0, 0x74, 0x30, 0xEC, 0xC0, 0x02, 0x38,  /* ,.t0...8 */
                    /* 0500 */  0x51, 0x68, 0xD3, 0xA7, 0x46, 0xA3, 0x56, 0x0D,  /* Qh..F.V. */
                    /* 0508 */  0xCA, 0xD4, 0x28, 0xD3, 0xA0, 0x56, 0x9F, 0x4A,  /* ..(..V.J */
                    /* 0510 */  0x8D, 0x19, 0x33, 0x04, 0xA5, 0x80, 0x0F, 0x01,  /* ..3..... */
                    /* 0518 */  0x9D, 0x08, 0x2C, 0xEF, 0xD9, 0x20, 0x10, 0xCB,  /* ..,.. .. */
                    /* 0520 */  0xA0, 0x10, 0x88, 0xA5, 0xBF, 0x5A, 0x04, 0xE2,  /* .....Z.. */
                    /* 0528 */  0xE0, 0x20, 0xFA, 0xFF, 0x83, 0x38, 0xE2, 0x93,  /* . ...8.. */
                    /* 0530 */  0x43, 0x60, 0xC4, 0x04, 0x18, 0x05, 0xA1, 0x11,  /* C`...... */
                    /* 0538 */  0x55, 0x80, 0x51, 0x1B, 0x60, 0x14, 0x84, 0x46,  /* U.Q.`..F */
                    /* 0540 */  0xD4, 0x01, 0x46, 0x8D, 0x80, 0x51, 0x10, 0x1A,  /* ..F..Q.. */
                    /* 0548 */  0x51, 0x09, 0x18, 0xB5, 0x02, 0x46, 0x41, 0x68,  /* Q....FAh */
                    /* 0550 */  0x44, 0x2D, 0x60, 0xD4, 0x0C, 0x18, 0x05, 0xA1,  /* D-`..... */
                    /* 0558 */  0x11, 0xD5, 0x80, 0x51, 0x3B, 0x60, 0x14, 0x84,  /* ...Q;`.. */
                    /* 0560 */  0x46, 0xD4, 0x03, 0x46, 0x57, 0x28, 0x30, 0x02,  /* F..FW(0. */
                    /* 0568 */  0x42, 0x23, 0x2A, 0x02, 0xA3, 0x96, 0xC0, 0x28,  /* B#*....( */
                    /* 0570 */  0x08, 0x8D, 0xA8, 0x09, 0x8C, 0x9A, 0x02, 0xA3,  /* ........ */
                    /* 0578 */  0x20, 0x34, 0xA2, 0x2A, 0x10, 0xF6, 0xFF, 0x07   /*  4.*.... */
                })
            }
        }

        Scope (\_SB.PCI0.PEGP.DGFX)
        {
            Method (NVOP, 4, Serialized)
            {
                Debug = "------- NV OPTIMUS DSM --------"
                Return (0x80000002)
            }
        }

        Name (PSBR, 0x00)
        Name (BRIN, 0x00)
        Name (TGIX, 0x01)
        Name (MUID, ToUUID ("4004a400-917d-4cf2-b89c-79b62fd55665"))
        Name (NUID, ToUUID ("d4a50b75-65c7-46f7-bfb7-41514cea0244"))
        Name (VUID, ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0"))
        Name (BLHD, Package (0x0A)
        {
            0x00, 
            0x02, 
            0x00, 
            0x00, 
            0x04, 
            0x01, 
            0x05DC, 
            0x00, 
            0x03E8, 
            0x00
        })
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If ((\SRCP == Arg0))
            {
                MUID
                0x01
                Return (MDSM (Arg0, Arg1, Arg2, Arg3))
            }

            If ((\SRCP == Arg0))
            {
                NUID
                0x01
                Return (NDSM (Arg0, Arg1, Arg2, Arg3))
            }

            If ((\SRCP == Arg0))
            {
                VUID
                0x01
                Return (NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000002)
        }

        Method (NDSM, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If ((Arg1 != 0x0102))
            {
                Return (0x80000002)
            }

            Local0 = Buffer (0x04)
                {
                     0x00, 0x00, 0x00, 0x00                           /* .... */
                }
            CreateDWordField (Local0, 0x00, NVRD)
            While (One)
            {
                _T_0 = ToInteger (Arg2)
                If ((_T_0 == 0x00))
                {
                    NVRD = 0x00180063
                    If ((\WCOS > 0x05))
                    {
                        WDPE |= 0x40
                    }

                    DCAP |= 0x07
                    Return (Local0)
                }
                Else
                {
                    If ((_T_0 == 0x01))
                    {
                        NVRD = 0x0250
                        Return (Local0)
                    }
                    Else
                    {
                        If ((_T_0 == 0x05))
                        {
                            CreateDWordField (Arg3, 0x00, ARGX)
                            CreateBitField (Arg3, 0x18, DMSK)
                            CreateField (Arg3, 0x19, 0x05, NCSN)
                            CreateBitField (Arg3, 0x1F, NCSM)
                            CreateField (Local0, 0x08, 0x06, TLSN)
                            If (NCSM)
                            {
                                TGIX = NCSN /* \_SB_.PCI0.PEGP.DGFX.NDSM.NCSN */
                            }

                            If (DMSK)
                            {
                                Local1 = (ARGX & 0x03FF)
                                WDST = TOHP (Local1)
                                Local1 = (ARGX >> 0x0C)
                                Local1 &= 0x03FF
                                WDSA = TOHP (Local1)
                                If ((WDSA == 0x01))
                                {
                                    WDGN |= 0x01
                                    If ((WDGN == 0x01))
                                    {
                                        TGIX = 0x01
                                    }
                                    Else
                                    {
                                        TGIX = 0x02
                                    }
                                }
                                Else
                                {
                                    If ((WDSA & 0x01))
                                    {
                                        If ((TGIX == 0x02))
                                        {
                                            WDGN = WDST /* External reference */
                                            TGIX = 0x03
                                        }
                                        Else
                                        {
                                            WDGN &= ~0x01
                                            TGIX = 0x04
                                        }
                                    }
                                    Else
                                    {
                                        WDGN = 0x01
                                        TGIX = 0x01
                                    }
                                }

                                If ((PSBR & 0x01))
                                {
                                    Signal (\_SB.F4EV)
                                    PSBR &= ~0x01
                                }
                            }

                            TLSN = TGIX /* \_SB_.PCI0.PEGP.DGFX.TGIX */
                            If ((PSBR & 0x04))
                            {
                                PSBR &= ~0x04
                            }

                            If (\_SB.DCKD)
                            {
                                NVRD |= 0x20
                            }

                            If ((PSBR & 0x02))
                            {
                                PSBR &= ~0x02
                            }

                            If (BRIN)
                            {
                                SBRV ()
                                BRIN = 0x00
                            }

                            Return (Local0)
                        }
                        Else
                        {
                            If ((_T_0 == 0x06))
                            {
                                If ((DerefOf (Index (MDTL, 0x00)) == 0x00))
                                {
                                    Local1 = _DOD ()
                                    Local0 = SizeOf (Local1)
                                    Local0++
                                    Index (MDTL, 0x00) = DerefOf (Index (Local1, 0x00))
                                    Index (MDTL, 0x01) = 0x2C
                                    Local5 = 0x00
                                    Local2 = 0x02
                                    Local3 = (Local2 + Local0)
                                    Local4 = (Local3 + Local0)
                                    While ((Local5 < (Local0 - 0x01)))
                                    {
                                        Local6 = DerefOf (Index (Local1, Local5))
                                        Index (MDTL, Local2) = Local6
                                        Local2++
                                        Index (MDTL, Local3) = Local6
                                        Local3++
                                        If ((Local5 > 0x00))
                                        {
                                            Index (MDTL, Local4) = Local6
                                            Local4++
                                        }

                                        Local5++
                                    }

                                    Index (MDTL, Local2) = 0x26
                                    Index (MDTL, Local3) = 0x2B
                                    Index (MDTL, Local4) = 0x2B
                                }

                                Return (MDTL) /* External reference */
                            }
                            Else
                            {
                                If ((_T_0 == 0x13))
                                {
                                    \_SB.ODGW (0xC007, CreateDWordField (Arg3, 0x00, ARGY))
                                    \_SB.ODGW (ARGY, NVRD = 0x04)
                                    \_SB.ODGW (0xC008, Return (NVRD) /* \_SB_.PCI0.PEGP.DGFX.NDSM.NVRD */)
                                }
                                Else
                                {
                                    If ((_T_0 == 0x14))
                                    {
                                        If ((\BCCT == 0x15))
                                        {
                                            Local7 = Package (0x34) {}
                                        }
                                        Else
                                        {
                                            Local7 = Package (0x20) {}
                                        }

                                        Local0 = 0x00
                                        Local2 = (SizeOf (BLHD) - 0x01)
                                        While ((Local0 < Local2))
                                        {
                                            Index (Local7, Local0) = DerefOf (Index (BLHD, Local0))
                                            Local0++
                                        }

                                        Index (Local7, Local0) = \BCCT /* External reference */
                                        Local1 = _DOD ()
                                        Local2 = DerefOf (Index (Local1, 0x00))
                                        Index (Local7, 0x00) = Local2
                                        If ((\WCOS < 0x06))
                                        {
                                            Index (Local7, 0x01) = 0x0100
                                        }

                                        If ((\WCOS > 0x06))
                                        {
                                            Index (Local7, 0x01) = 0x0200
                                        }

                                        Local5 = BRLV /* External reference */
                                        Local6 = BCLV /* External reference */
                                        Local0 = 0x00
                                        While ((Local0 < \BCCT))
                                        {
                                            Local2 = (Local0 + SizeOf (BLHD))
                                            Local1 = DerefOf (Index (Local5, Local0))
                                            Local3 = (Local1 * 0x03E8)
                                            Divide ((Local3 + 0x7F), 0xFF, Local4, Local1)
                                            Index (Local7, Local2) = Local1
                                            Local2 += \BCCT /* External reference */
                                            Local1 = DerefOf (Index (Local6, (Local0 + 0x02)))
                                            Index (Local7, Local2) = (Local1 * 0x0A)
                                            Local0++
                                        }

                                        Return (Local7)
                                    }
                                }
                            }
                        }
                    }
                }

                Break
            }

            Return (0x80000002)
        }

        Method (DKET, 0, Serialized)
        {
            PSBR |= 0x04
            Notify (^, 0x81) // Information Change
            Return (0x01)
        }

        Method (GF4E, 0, Serialized)
        {
            PSBR |= 0x01
            Notify (^, 0x80) // Status Change
            Return (0x01)
        }

        Method (GLEV, 0, Serialized)
        {
            PSBR |= 0x02
            Notify (^, 0xDB) // Hardware-Specific
        }

        Method (GPUP, 0, Serialized)
        {
            Local0 = 0xD3
            If ((\_SB.PCI0.LPCB.EC0.GACS == 0x01))
            {
                If ((\_SB.PCI0.LPCB.EC0.GPID == 0x00))
                {
                    Local0 = 0xD1
                }
                Else
                {
                    Local0 = 0xD2
                }
            }

            Notify (^, Local0)
            Return (0x01)
        }

        Method (SBRV, 0, Serialized)
        {
            Local1 = \_SB.SBRC /* External reference */
            If (APBX (0x02))
            {
                If (PBIA ())
                {
                    Local2 = (Local1 * 0x03E8)
                    Divide (Local2, 0xFF, Local3, Local1)
                    PBDI = (Local1 << 0x08)
                    SPBC (0x86100000)
                }

                RPBX (0x02)
            }

            Return (0x01)
        }

        Method (RFHS, 1, Serialized)
        {
            Wait (\_SB.F4EV, 0x0500)
        }

        Method (SNXS, 0, Serialized)
        {
            Return (0x00)
        }

        Method (VWAK, 1, Serialized)
        {
            If ((Arg0 >= 0x03))
            {
                If (((WDPE & 0x44) == 0x00))
                {
                    \_SB.ODGW (0xD5F2, BRIN = 0x01)
                }
            }
        }

        Method (TOHP, 1, Serialized)
        {
            Local1 = DODI /* External reference */
            Local3 = SizeOf (Local1)
            Local0 = 0x00
            Local7 = Arg0
            Local2 = 0x00
            While (((Local0 < Local3) && Local7))
            {
                Local4 = (0x01 << Local0)
                If ((Local7 & Local4))
                {
                    Local5 = DerefOf (Index (Local1, Local0))
                    Local6 = (0x01 << Local5)
                    Local2 |= Local6
                }

                Local7 &= ~Local4
                Local0++
            }

            Return (Local2)
        }

        Method (DGCE, 0, Serialized)
        {
            Return (0x00)
        }

        OperationRegion (GPPB, PCI_Config, 0xB4, 0x14)
        Field (GPPB, ByteAcc, NoLock, Preserve)
        {
            PBCI,   8, 
            PBNP,   8, 
            PBLS,   8, 
            PBCC,   8, 
            PBCR,   32, 
            PBDI,   32, 
            PBDO,   32, 
            PBMX,   32
        }

        Method (APBX, 1, Serialized)
        {
            Local1 = 0x00
            If ((PBCC & 0x01))
            {
                Local0 = 0x28
                While ((Local0 > 0x00))
                {
                    While (((PBMX != 0x00) && (Local0 > 0x00)))
                    {
                        Sleep (0x32)
                        Local0--
                    }

                    If ((PBMX == 0x00))
                    {
                        PBMX = Arg0
                        If ((PBMX == Arg0))
                        {
                            Local1 = 0x01
                            Break
                        }
                    }
                }
            }

            Return (Local1)
        }

        Method (RPBX, 1, Serialized)
        {
            Local0 = 0x14
            While (((PBMX == Arg0) && (Local0 > 0x00)))
            {
                PBMX = 0x00
                Local0--
            }
        }

        Method (PBIA, 0, Serialized)
        {
            Local0 = 0x0A
            While (((PBCR & 0x02) && (Local0 > 0x00)))
            {
                Sleep (0x01)
                Local0--
            }

            If ((PBCR & 0x02))
            {
                Local1 = 0x00
            }
            Else
            {
                Local1 = 0x01
            }

            Return (Local1)
        }

        Method (SPBC, 1, Serialized)
        {
            PBCR = Arg0
        }

        Scope (\_SB.PCI0.PEGP.DGFX)
        {
            OperationRegion (REVD, SystemMemory, VRMB (VRMS ()), Field (REVD, AnyAcc, NoLock, Preserve)
                {
                    SROM,   32, 
                    VROM,   1277952
                })
        }

        Scope (\_SB.PCI0.PEGP.DGFX)
        {
            Method (_ROM, 2, NotSerialized)  // _ROM: Read-Only Memory
            {
                Local0 += Arg0 = (VRMB (0x04) + Local0)
                Local1 = (VRMS () - 0x04)
                If ((Arg0 < Local1))
                {
                    OperationRegion (OROM, SystemMemory, Local0, 0x1000)
                    Field (OROM, AnyAcc, NoLock, Preserve)
                    {
                        R4KB,   32768
                    }

                    Return (R4KB) /* \_SB_.PCI0.PEGP.DGFX._ROM.R4KB */
                }
                Else
                {
                    Local0 = Buffer (0x01)
                        {
                             0x00                                             /* . */
                        }
                    Return (Local0)
                }
            }
        }

        Method (LCD._DDC, 1, Serialized)  // _DDC: Display Data Current
        {
            Return (\_SB.HDDC) /* External reference */
            Arg0
        }
    }
}

